#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"
#include "pd.h"

PD code2PD(code c) {
  PD p;
  p.n = c.n;
  p.crossings = malloc(p.n * sizeof(int *));
  int i;
  for (i = 0; i < p.n; i++)
    p.crossings[i] = malloc(4 * sizeof(int));
  for (i = 0; i < 2 * c.n; i++) {
    int ii = (i + 1) % (2 * c.n);
    if (c.code[i] % 3 == 0) // outgoing from negative crossing
      if (crossings[c.code[i]].p == O)
	p.crossings[c.code[i] / 6][3] = i;
      else
	p.crossings[c.code[i] / 6][2] = i;
    else // outgoing from positive crossings
      if (crossings[c.code[i]].p == O)
	p.crossings[c.code[i] / 6][1] = i;
      else
	p.crossings[c.code[i] / 6][2] = i;
    if (c.code[ii] % 3 == 0) // incoming to negative crossing
      if (crossings[c.code[ii]].p == O)
	p.crossings[c.code[ii] / 6][1] = i;
      else
	p.crossings[c.code[ii] / 6][0] = i;
    else // incoming to positive crossing
      if (crossings[c.code[ii]].p == O)
	p.crossings[c.code[ii] / 6][3] = i;
      else
	p.crossings[c.code[ii] / 6][0] = i;
  }
  return p;
}

void freePD(PD p) {
  int i;
  for (i = 0; i < p.n; i++)
    free(p.crossings[i]);
  free(p.crossings);
}

void printPD(PD p) {
  int i;
  for (i = 0; i < p.n; i++)
    printf("X[%d,%d,%d,%d] ", p.crossings[i][0] + 1,
	  p.crossings[i][1] + 1, p.crossings[i][2] + 1, p.crossings[i][3] + 1);
  printf("\n");
}

char *sprintPD(PD p) {
  int i, j = 0;
  char *s = malloc((21 * (p.n + 1)) * sizeof(char)); // assumes < 50 crossings
  s[0] = '\0';
  for (i = 0; i < p.n; i++)
    j += sprintf(s + j, "X[%d,%d,%d,%d], ", p.crossings[i][0] + 1,
	        p.crossings[i][1]+1, p.crossings[i][2]+1, p.crossings[i][3]+1);
  if (j > 1)
    s[j - 2] = '\0';
  return s;
}
