#include <stdlib.h>
#include "gauss.h"
#include "poly.h"
#include "polytrees.h"

int addtotwotree(twopolytree *t, twopoly p, knot n) { // returns 1 if p
  int cmp = comparetwopoly(p, t->p);                  // shouldn't be freed
  if (cmp == 0) {
    knotlist *l = t->codes;
    while (l->next != NULL)
      l = l->next;
    l->next = malloc(sizeof(knotlist));
    l = l->next;
    l->next = NULL;
    l->n = n;
    //freetwopoly(p);//this is only called by main(), and it's appropriate here
    return 0;
  } else if (cmp == -1) {
    if (t->left != NULL) {
      return addtotwotree(t->left, p, n);
      //return;
    } else {
      t->left = calloc(1, sizeof(twopolytree));
      t = t->left;
    }
  } else {
    if (t->right != NULL) {
      return addtotwotree(t->right, p, n);
      //return;
    } else {
      t->right = calloc(1, sizeof(twopolytree));
      t = t->right;
    }
  }
  t->p = p;
  t->codes = malloc(sizeof(knotlist));
  t->codes->next = NULL;
  t->codes->n = n;
  return 1;
}

int addtotree(polytree *t, poly p, knot n) { // returns 1 if p shouldn't
  int cmp = comparepoly(p, t->p);            // be freed
  if (cmp == 0) {
    knotlist *l = t->codes;
    while (l->next != NULL)
      l = l->next;
    l->next = malloc(sizeof(knotlist));
    l = l->next;
    l->next = NULL;
    l->n = n;
    //free(p.coeffs);//this is only called by main(), and it's appropriate here
    return 0;
  } else if (cmp == -1) {
    if (t->left != NULL) {
      return addtotree(t->left, p, n);
      //return;
    } else {
      t->left = calloc(1, sizeof(polytree));
      t = t->left;
    }
  } else {
    if (t->right != NULL) {
      return addtotree(t->right, p, n);
      //return;
    } else {
      t->right = calloc(1, sizeof(polytree));
      t = t->right;
    }
  }
  t->p = p;
  t->codes = malloc(sizeof(knotlist));
  t->codes->next = NULL;
  t->codes->n = n;
  return 1;
}

knotlist *pgetknots(polytree *t, poly p) {
  if (t == NULL)
    return NULL;
  int cmp = comparepoly(p, t->p);
  if (cmp == -1)
    return pgetknots(t->left, p);
  if (cmp == 1)
    return pgetknots(t->right, p);
  return t->codes;
}

knotlist *tpgetknots(twopolytree *t, twopoly p) {
  if (t == NULL)
    return NULL;
  int cmp = comparetwopoly(p, t->p);
  if (cmp == -1)
    return tpgetknots(t->left, p);
  if (cmp == 1)
    return tpgetknots(t->right, p);
  return t->codes;
}
